###########################################################
##TestStoreProcess is the method to get the performance 
###results of the store method.
####Uses trace generator to get a set of traces.
####Invokes store method with each input trace, and the property, and the set of accepting locations in the property.
#### For each trace, the trace length, the total execution time of update returned by the store method, and the average execution time is kept track.
#############################################################


########################################################
########################################################
import time
from threading import Timer
import StoreProcess
import TraceGenerator
import sys
import os.path
import shutil
#########################################################

########################################################
####### "testStoreProcess" is the main test method which invokes the store method 
####### with the property and an input trace and keeps track of the execution time results returned by the store method.
########################################################
def testStoreProcess(property, accLoc, actions, delays, numTraces, incrementPerTrace):
    testResults = []
    perTrace = []
    ##invoke the trace generator method. 
    ###Store the result returned in "inputTraces"
    ####Parameters are possible actions, possible delays, number of traces and increment in length per trace.
    inputTraces = TraceGenerator.genTraces(actions, delays, numTraces, incrementPerTrace)
    
    ###invoking the store method for each input trace.
    for i in range(0,inputTraces.__len__()):
        shutil.copy(property, "Example_Gen.xml")
        propertyC = "Example_Gen.xml"
        
        trace = inputTraces.pop()
        traceLength = trace.__len__()

        ##For each trace, invoke the store for "n" number of times, to take an average of the execution time per trace over multiple runs.
        testResultsPerTrace = []
        for j in range(1,11):
            result = StoreProcess.store(propertyC,accLoc, trace)
            #print "store returned..." + str(updateTime)
            testResultsPerTrace.append((traceLength, result[0], result[0]/traceLength))
    
        Sum_tot = 0.0
        Sum_per = 0.0
            
        ### Compute average per trace and store the result in "testResults"
        for i in range(0,testResultsPerTrace.__len__()):
            Sum_tot = Sum_tot + testResultsPerTrace[i][1]
            Sum_per =  Sum_per + testResultsPerTrace[i][2]
        Avg_t = Sum_tot/testResultsPerTrace.__len__()
        Avg_p = Sum_per/testResultsPerTrace.__len__()
        testResults.append((traceLength, Avg_t, Avg_p))
        perTrace.append(testResultsPerTrace)
        #print "Avg total.." + str(Avg_t)
        #print "Avg_per.." + str(Avg_p)
    print "TEst results.." + str(testResults) 
           

##invoking the main test method        
#testStoreProcess('Co-SafetyExistanceP1.xml',["S2"], ['G','R'], [1,2,3,4,5], 1, 700)
#testStoreProcess('response1.xml', ["S0"], ['G','R'], [1,2,3,4,5], 1,60000)
#testStoreProcess('Example_Safety.xml', ["S1", "S2"], ['a','r'], [1,2,3,4,5], 1,10)


if __name__ == "__main__":
    property = (sys.argv[1])
    accLoc = (sys.argv[2])
    actions = (sys.argv[2])
    delays = (sys.argv[3])
    numTraces = int(sys.argv[4])
    incrPerTrace = int(sys.argv[5])
    testStoreProcess(property,accLoc, actions, delays, numTraces,incrPerTrace)
























